<?php
/**
 * Chemical formula
 * 
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Ikuo Obataya <I.Obataya@gmail.com>
 */
 
// must be run within Dokuwiki
if(!defined('DOKU_INC')) die();
 
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');
 
/**
 * All DokuWiki plugins to extend the parser/rendering mechanism
 * need to inherit from this class
 */
class syntax_plugin_chem extends DokuWiki_Syntax_Plugin {
 
    /**
     * return some info
     */
    function getInfo(){
        return array(
            'author' => 'Ikuo Obataya',
            'email'  => 'I.Obataya@gmail.com',
            'date'   => '2007-10-23',
            'name'   => 'Chemical Formula Plugin',
            'desc'   => 'Format chemical formula',
            'url'    => 'http://wiki.symplus.co.jp/computer/en/chem_plugin',
        );
    }
 
    function getType(){ return 'formatting'; }
    function getAllowedTypes() { return array('formatting', 'substition', 'disabled'); }   
    function getSort(){ return 158; }
    function connectTo($mode) { $this->Lexer->addEntryPattern('<chem>(?=.*?</chem>)',$mode,'plugin_chem'); }
    function postConnect() { $this->Lexer->addExitPattern('</chem>','plugin_chem'); }
 
 
    /**
     * Handle the match
     */
    function handle($match, $state, $pos, &$handler){
        switch ($state) {
          case DOKU_LEXER_ENTER :
                return array($state, '');
 
          case DOKU_LEXER_UNMATCHED :  return array($state, $match);
          case DOKU_LEXER_EXIT :       return array($state, '');
        }
        return array();
    }
 
    /**
     * Create output
     */
    function render($mode, &$renderer, $data) {
        if($mode == 'xhtml'){
            list($state, $match) = $data;
            switch ($state) {
              case DOKU_LEXER_ENTER :
                break;
                
              case DOKU_LEXER_UNMATCHED :  
                // modified on 2007-10-23
                $pattern = array("/[\|]?([0-9]*\+|[0-9]*\-)/","/([A-Z]|[A-Z][a-z]|\)|\])([0-9]+)/");
                $replace = array("<sup>\${1}</sup>","\${1}<sub>\${2}</sub>");
                $renderer->doc .= preg_replace($pattern,$replace,$match);
      // $renderer->doc .= $renderer->_xmlEntities($match); 
      break;
              case DOKU_LEXER_EXIT :       break;
            }
            return true;
        }
        return false;
    }
 }
